package com.muyu.marketing.domain.model;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.muyu.marketing.domain.req.ActivityTeamInfoSaveReq;
import com.muyu.marketing.domain.req.ProjectSkuInfoAddReq;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 团购活动添加模型
 *
 * @author DongZeLiang
 * @date 2024-11-26 09:38
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamInfoAddModel {

    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private Long productId;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位
     */

    private String unit;
    /**
     * 轮播图
     */

    private String imageList;
    /**
     * 活动结束时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd")
    private Date endTime;
    /**
     * 活动排序
     */
    private Integer sort;
    /**
     * 商品SkU集合
     */
    private List<ActivityTeamProductSkuAddModel> activityTeamProductSkuAddModelList;
    /**
     * 活动详情
     */
    private String content;
    /**
     * 活动状态
     */
    private String status;
    /**
     * 策略类型
     */
    private String strategyType;
    /**
     * 策略ID
     */
    private Long strategyId;

    /** addReq 转话addModel模型**/
    public static ActivityTeamInfoAddModel convertAddModel(ActivityTeamInfoSaveReq addReq) {
        List<ProjectSkuInfoAddReq> addReqList = addReq.getProjectSkuInfoAddReqList();
        addReqList.stream().map(skuInfoAdd->{ActivityTeamProductSkuAddModel.convertProductSkuList(skuInfoAdd);
        } ).toList();

        ActivityTeamProductSkuAddModel.convertProductSkuList();
       return ActivityTeamInfoAddModel.builder()
                .name(addReq.getName())
                .productId(addReq.getProductId())
                .productImage(addReq.getProductImage())
                .introduction(addReq.getIntroduction())
                .unit(addReq.getUnit())
                .imageList(addReq.getImageList())
                .endTime(addReq.getEndTime())
                .sort(addReq.getSort())
                .activityTeamProductSkuAddModelList(addModelList)
                .content(addReq.getContent())
                .status(addReq.getStatus())
                .strategyType(addReq.getStrategyType())
                .strategyId(addReq.getStrategyId())
                .build();
    }


}
